
package com.rimfaxe.thread;

import java.io.FileInputStream;
import java.util.Enumeration;
import java.util.Properties;

/** This class is the ReportingExceptionHandler. It is used to handle all Exceptions.
 * It adds severities and then sends them to the ReportingLogger.
 */

public class ReportingExceptionHandler extends Object {
    /* Members -------------------------------------------------------------- */


    /* Constructors --------------------------------------------------------- */
    /** Creates new ReportingExceptionHandler
     */
    public ReportingExceptionHandler()
    {
        // ConfigManager must already be initialized
    }

    /* External Functions --------------------------------------------------- */

    /** processes a Reporting exception
     */
    public static void processException(ReportingException aReportingException)
    {

        try {

            ReportingException lReportingException = aReportingException;
            String lStackTrace = null;
            Throwable lNestedException = lReportingException.getNestedException();
            String lKey = lReportingException.getMessage();
            ReportingLogger.logError(lKey);

            // gives back identifying key for the exception
            while (lNestedException != null) {
                lReportingException = (ReportingException)lNestedException;
                lNestedException = lReportingException.getNestedException();
                lKey = lReportingException.getMessage();
                ReportingLogger.logError(lKey);
            }

            lStackTrace = lReportingException.getTrace();
            ReportingLogger.logError(lStackTrace);

        } catch (Exception eException) {
            System.out.println("Exception Handler eException");
            ReportingLogger.logError(eException.getMessage());

        }
    }
}
