/*
 * RimfaxeList.java
 *
 *
 * Copyright (c) 2003 Rimfaxe ApS  (www.rimfaxe.com).  
 * All rights reserved.
 *
 * This package is written by Lars Andersen <lars@rimfaxe.com> 
 * and licensed by Rimfaxe ApS.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by Rimfaxe ApS
          (www.rimfaxe.com)"
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Rimfaxe", "Rimfaxe Software", "Lars Andersen" and 
 *    "Rimfaxe WebServer" must not be used to endorse or promote products 
 *    derived from this software without prior written permission. For written
 *    permission, please contact info@rimfaxe.com
 *
 * 5. Products derived from this software may not be called "Rimfaxe"
 *    nor may "Rimfaxe" appear in their names without prior written
 *    permission of the Rimfaxe ApS.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package com.rimfaxe.util;

import java.util.*;

/**
 *
 * @author  Lars Andersen
 */
public class RimfaxeList extends java.util.ArrayList 
{
    
  /** Creates a new instance of RimfaxeList */
  public RimfaxeList() 
  {
    super();
  }
  
  public Object find(String name)
  {
    for (int i=0; i<this.size(); i++)
    {
      Object tmp = this.get(i);
      if (tmp.toString().equalsIgnoreCase(name)) 
        return tmp;
    }  
    return null;  
  }
  
  public boolean contains(Object val)
  {
    boolean b = false;
    if (find(""+val)!=null) b=true;
    
    return b;
  }
  
  public boolean containsDoubles(Object val)
  {
    int num = 0;
    for (int i=0; i<this.size(); i++)
    {
      Object tmp = this.get(i);
      if (tmp.toString().equalsIgnoreCase(val.toString())) 
        num++;
    }  
    return (num>1);
  }
  
  public int position(Object val)
  {
    int res=-1;  
    for (int i=0; i<this.size(); i++)
    {
      Object tmp = this.get(i);
      if (tmp.toString().equalsIgnoreCase(val.toString())) 
         res = i; 
    }  
    return res;
  } 
    
  public int removeDoubles()
  {
    int num = 0;
    for (int i=0; i<this.size(); i++)
    {
      Object o = this.get(i);
      if (this.containsDoubles(o))
      {
        this.remove( position(o) );
        num++;
        i--;
      }
    }  
    return num;
  }
 
  public void removeObject(Object val)
  {
    int pos = this.position(val);
    this.remove(pos);
  }
  
  public String getPostStr(String prefix)
  {
    return getPostStr(prefix,".");
  }

  public String getPostStr(String prefix, String separator)
  {
    for (int i=0; i<this.size(); i++)
    {
      String tmp = "" + this.get(i);
      StringTokenizer tkz = new StringTokenizer(tmp,separator,false);
      if (tkz.hasMoreTokens())
        if (tkz.nextToken().equalsIgnoreCase(prefix))
          return tkz.nextToken();
    }  
    return null;
  }
  
}
