/*
 * RimfaxeVector.java
 *
 *
 * Copyright (c) 2003 Rimfaxe ApS  (www.rimfaxe.com).  
 * All rights reserved.
 *
 * This package is written by Lars Andersen <lars@rimfaxe.com> 
 * and licensed by Rimfaxe ApS.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by Rimfaxe ApS
          (www.rimfaxe.com)"
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Rimfaxe", "Rimfaxe Software", "Lars Andersen" and 
 *    "Rimfaxe WebServer" must not be used to endorse or promote products 
 *    derived from this software without prior written permission. For written
 *    permission, please contact info@rimfaxe.com
 *
 * 5. Products derived from this software may not be called "Rimfaxe"
 *    nor may "Rimfaxe" appear in their names without prior written
 *    permission of the Rimfaxe ApS.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
 
package com.rimfaxe.util;

import java.util.*;
/** 
 *
 * @author Lars Andersen
 */
public class RimfaxeVector extends Vector 
{
  /** Creates new SetVector */
    public RimfaxeVector() 
  {
    super();
  }
  
  public Object find(String name)
  {
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      Object tmp = enum.nextElement();
    
      if (tmp.toString().equalsIgnoreCase(name.toString())) 
        return tmp;
    }  
    return null;  
  }
  
  public boolean contains(Object val)
  {
    boolean b = false;
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      String str = "" + enum.nextElement();
      if (str.equalsIgnoreCase(val.toString())) 
        b = true;
    }
    return b;
  }
  
  public boolean containsDoubles(Object val)
  {
    int num = 0;
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      String str = "" + enum.nextElement();
      if (str.equalsIgnoreCase(val.toString())) 
        num++;
    }
    return (num>1);
  }
  
  public int position(Object val)
  {
    Enumeration enum = this.elements();
    int i=0;
    int res=-1;
    while (enum.hasMoreElements())
    {
      Object o = enum.nextElement();
      if (o.toString().equalsIgnoreCase( val.toString() ))
        res = i;
      i++;
    }
    return res;
  } 
  
  
  public int removeDoubles(int times)
  {
    int num = 0;
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      Object o = enum.nextElement();
      
      if (this.containsDoubles(o))
      {
        this.removeElementAt( position(o) );
        num++;
      }
    }
    return num;
  }
 
  public int removeDoubles()
  {
    while (this.removeDoubles(0)!=0) {}
    return 0;
  }
  
  public void removeObject(Object val)
  {
    int pos = this.position(val);
    this.removeElementAt(pos);
  }
  
  public String getPostStr(String prefix)
  {
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      String tmp = "" + enum.nextElement();
      StringTokenizer tkz = new StringTokenizer(tmp,".",false);
      if (tkz.hasMoreTokens())
        if (tkz.nextToken().equalsIgnoreCase(prefix))
          return tkz.nextToken();
    }
    return null;
  }

  public String getPostStr(String prefix, String separator)
  {
    Enumeration enum = this.elements();
    while (enum.hasMoreElements())
    {
      String tmp = "" + enum.nextElement();
      StringTokenizer tkz = new StringTokenizer(tmp,separator,false);
      if (tkz.hasMoreTokens())
        if (tkz.nextToken().equalsIgnoreCase(prefix))
          return tkz.nextToken();
    }
    return null;
  }
}