/*
 * RimfaxeServletConfig.java
 *
 *
 * Copyright (c) 2003 Rimfaxe ApS  (www.rimfaxe.com).  
 * All rights reserved.
 *
 * This package is written by Lars Andersen <lars@rimfaxe.com> 
 * and licensed by Rimfaxe ApS.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by Rimfaxe ApS
          (www.rimfaxe.com)"
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Rimfaxe", "Rimfaxe Software", "Lars Andersen" and 
 *    "Rimfaxe WebServer" must not be used to endorse or promote products 
 *    derived from this software without prior written permission. For written
 *    permission, please contact info@rimfaxe.com
 *
 * 5. Products derived from this software may not be called "Rimfaxe"
 *    nor may "Rimfaxe" appear in their names without prior written
 *    permission of the Rimfaxe ApS.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package com.rimfaxe.webserver.servletapi;

import java.util.*;

import com.rimfaxe.util.RimfaxeVector;

/**
 *
 * @author  Lars Andersen
 */
public class RimfaxeServletConfig implements javax.servlet.ServletConfig
{    
  String name = "unknown";  
  Hashtable params = new Hashtable();
  javax.servlet.ServletContext servletcontext;
  
  /** Creates a new instance of RimfaxeServletConfig */
  public RimfaxeServletConfig(String name, javax.servlet.ServletContext ctx) 
  {
    this.name = name;
    this.servletcontext = ctx;
    
    params.put("debug","0");
    params.put("listings","true");
  }
   
  /** Creates a new instance of RimfaxeServletConfig */
  public RimfaxeServletConfig(String name, javax.servlet.ServletContext ctx, com.rimfaxe.webserver.webapp.Servlet servlet_def) 
  {
    this.name = name;
    this.servletcontext = ctx;
    
    //params.put("debug","0");
    //params.put("listings","true");
    
    Iterator iter = servlet_def.getParameters();
    while (iter.hasNext())
    {
       com.rimfaxe.webserver.webapp.InitParameter ip = (com.rimfaxe.webserver.webapp.InitParameter) iter.next();
       params.put(ip.getName(), ip.getValue() );
       
    }
    
  }
  
  public void setInitParameter(String key, Object val)
  {
    params.put(key,val);    
  }
  
  public String getInitParameter(String str) 
  {
    return ""+params.get(str);  
  }
    
  public java.util.Enumeration getInitParameterNames() 
  {
    return params.keys();  
  }
    
  public javax.servlet.ServletContext getServletContext() 
  {
    //System.out.println("ServletConfig, get servlet context");    
    return servletcontext;  
  }
    
  public String getServletName() 
  {
    return this.name;  
  }
    
}
