/*
 * ErrorMessage.java
 *
 *
 * Copyright (c) 2003 Rimfaxe ApS  (www.rimfaxe.com).  
 * All rights reserved.
 *
 * This package is written by Lars Andersen <lars@rimfaxe.com> 
 * and licensed by Rimfaxe ApS.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by Rimfaxe ApS
          (www.rimfaxe.com)"
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Rimfaxe", "Rimfaxe Software", "Lars Andersen" and 
 *    "Rimfaxe WebServer" must not be used to endorse or promote products 
 *    derived from this software without prior written permission. For written
 *    permission, please contact info@rimfaxe.com
 *
 * 5. Products derived from this software may not be called "Rimfaxe"
 *    nor may "Rimfaxe" appear in their names without prior written
 *    permission of the Rimfaxe ApS.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package com.rimfaxe.webserver.servletapi.standard;

import java.util.*;

/**
 *
 * @author  Lars Andersen
 */
public class ErrorMessage 
{
    
  /** Creates a new instance of Error404 */ 
    public ErrorMessage() 
  {
  }
  
  public String getHTML(String uri, String error_msg, String error_found)
  {
    StringBuffer buf = new StringBuffer();
    
        buf.append("<html>");
        buf.append("<head>"); 
        buf.append("<title>Rimfaxe Web Server - Error report</title>");
        buf.append("</head>");
        buf.append("<body>"); 
        buf.append("<table border=\"1\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
        buf.append("<tr>");
        buf.append("<td height=\"50\" bgcolor=\"orange\">");
        buf.append("<p style=\"margin-left: 10px; font-weight: bold; font-size: 16pt\">");
        buf.append("Rimfaxe Web Server - Error report");
        buf.append("</p>");
        buf.append("</td>");
        buf.append("</tr>");
        buf.append("<tr>");
        buf.append("<td>");     
        buf.append("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
        buf.append("<tr>");
        buf.append("<td>");
        
        buf.append("<br><p style=\"margin-left: 10px; font-size: 12pt; font-weight: bold\">");
        buf.append(""+error_found);
        buf.append("</p>");
        
        buf.append("<p style=\"margin-left: 10px; font-size: 10pt\">");
        buf.append(""+error_msg);
        buf.append("</p><br> <br>");
        buf.append("</td>");
        buf.append("</tr>");
        buf.append("</table>");
        buf.append("</td>");
        buf.append("</tr>");
        buf.append("<tr>");
        buf.append("<td height=\"15\" bgcolor=\"orange\">");
        buf.append("<p style=\"margin-left: 10px; font-color: white; font-size: 10pt\">");
        buf.append("<b>"+com.rimfaxe.webserver.ObjectStore.getConfiguration().getBanner()+"</b> &nbsp;&nbsp; - <a href=\"http://www.rimfaxe.com\">Rimfaxe Software</a>");
        buf.append("</p>");
        buf.append("</td>");
        buf.append("</tr>");
        buf.append("</table>");
        buf.append("</body>");
        buf.append("</html>");
        
    return ""+buf;    
  }
    
}
