/*
 * ErrorServlet.java
 *
 *
 * Copyright (c) 2003 Rimfaxe ApS  (www.rimfaxe.com).  
 * All rights reserved.
 *
 * This package is written by Lars Andersen <lars@rimfaxe.com> 
 * and licensed by Rimfaxe ApS.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by Rimfaxe ApS
          (www.rimfaxe.com)"
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "Rimfaxe", "Rimfaxe Software", "Lars Andersen" and 
 *    "Rimfaxe WebServer" must not be used to endorse or promote products 
 *    derived from this software without prior written permission. For written
 *    permission, please contact info@rimfaxe.com
 *
 * 5. Products derived from this software may not be called "Rimfaxe"
 *    nor may "Rimfaxe" appear in their names without prior written
 *    permission of the Rimfaxe ApS.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

package com.rimfaxe.webserver.servletapi.standard;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author  Lars Andersen
 */
public class ErrorServlet extends HttpServlet 
{
    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException 
    {
        super.init(config);    
    }
    
    /** Destroys the servlet.
     */
    public void destroy() 
    {    
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, java.io.IOException 
    {
        response.setContentType("text/html");
        java.io.PrintWriter out = response.getWriter();
        
        
       
        out.println("<html>");
        out.println("<head>"); 
        out.println("<title>Rimfaxe Web Server - Error report</title>");
        out.println("</head>");
        out.println("<body>"); 
        out.println("<table border=\"1\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
        out.println("<tr>");
        out.println("<td height=\"50\" bgcolor=\"orange\">");
        out.println("<p style=\"margin-left: 10px; font-weight: bold; font-size: 16pt\">");
        out.println("Rimfaxe Web Server - Error report");
        out.println("</p>");
        out.println("</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td>");     
        out.println("<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">");
        out.println("<tr>");
        out.println("<td>");
        
        out.println("<br><p style=\"margin-left: 10px; font-size: 12pt; font-weight: bold\">");
        out.println(""+this.getServletConfig().getInitParameter("com.rimfaxe.error_found"));
        out.println("</p>");
        
        out.println("<p style=\"margin-left: 10px; font-size: 10pt\">");
        out.println(""+this.getServletConfig().getInitParameter("com.rimfaxe.error_msg"));
        out.println("</p><br> <br>");
        out.println("</td>");
        out.println("</tr>");
        out.println("</table>");
        out.println("</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td height=\"15\" bgcolor=\"orange\">");
        out.println("<p style=\"margin-left: 10px; font-color: white; font-size: 10pt\">");
        out.println("<b>"+com.rimfaxe.webserver.ObjectStore.getConfiguration().getBanner()+"</b> &nbsp;&nbsp; - <a href=\"http://www.rimfaxe.com\">Rimfaxe Software</a>");
        out.println("</p>");
        out.println("</td>");
        out.println("</tr>");
        out.println("</table>");
        out.println("</body>");
        out.println("</html>");
        out.close();
    }
    
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    
}
