package com.rimfaxe.xml.compatibility;

import org.w3c.dom.*;

/**
 * Standard wrapper around spartan Text node.

   <blockquote><small> Copyright (C) 2002 Hewlett-Packard Company.
   This file is part of Sparta, an XML Parser, DOM, and XPath library.
   This library is free software; you can redistribute it and/or
   modify it under the terms of the <a href="doc-files/LGPL.txt">GNU
   Lesser General Public License</a> as published by the Free Software
   Foundation; either version 2.1 of the License, or (at your option)
   any later version.  This library is distributed in the hope that it
   will be useful, but WITHOUT ANY WARRANTY; without even the implied
   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE. </small></blockquote>
   @version  $Date: 2002/11/06 02:59:55 $  $Revision: 1.3 $
   @author Eamonn O'Brien-Strain
 */

public class TextImpl extends NodeImpl implements org.w3c.dom.Text, org.w3c.dom.CDATASection {

    public Text splitText(int parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.Text method*/
        throw new Error("not implemented: splitText()");
    }
    public void appendData(String parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: appendData()");
    }
    public void deleteData(int parm1, int parm2)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: deleteData()");
    }
    public String getData() throws org.w3c.dom.DOMException {
        return getSpartanText().getData();
    }
    public int getLength() {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: getLength()");
    }
    public void insertData(int parm1, String parm2)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: insertData()");
    }
    public void replaceData(int parm1, int parm2, String parm3)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: replaceData()");
    }
    public void setData(String parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: setData()");
    }
    public String substringData(int parm1, int parm2)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.CharacterData method*/
        throw new Error("not implemented: substringData()");
    }
    public Node appendChild(Node parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: appendChild()");
    }
    public Node cloneNode(boolean parm1) {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: cloneNode()");
    }
    public NamedNodeMap getAttributes() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: getAttributes()");
    }
    public NodeList getChildNodes() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: getChildNodes()");
    }
    public Node getFirstChild() {
        return null;
    }
    public Node getLastChild() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: getLastChild()");
    }

    /** Always return null */
    public String getLocalName() {
        return null;
    }

    /** Always return null */
    public String getNamespaceURI() {
        return null;
    }
    public String getNodeName() {
        return "#text";
    }
    public short getNodeType() {
        return Node.TEXT_NODE;
    }
    public String getNodeValue() throws org.w3c.dom.DOMException {
        return getSpartanText().getData();
    }

    public org.w3c.dom.Node getParentNode() {
        if( getSpartan().getParentNode()==null )
            return null;
        else{
            com.rimfaxe.xml.xmlreader.Element spartanParent
                = getSpartan().getParentNode();
            return ((DocumentImpl)getOwnerDocument()).wrapper( spartanParent );
        }

    }

    public String getPrefix() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: getPrefix()");
    }
    public boolean hasAttributes() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: hasAttributes()");
    }

    /** ALways returns false. */
    public boolean hasChildNodes() {
        return false;
    }
    public Node insertBefore(Node parm1, Node parm2)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: insertBefore()");
    }

    public boolean isSupported(String feature, String version) {
        if( feature.equals("http://xml.apache.org/xpath/features/whitespace-pre-stripping") )
            return false;
        else if( feature.equals("http://xml.apache.org/xalan/features/feed-events") )
            return false;
        else if( feature.equals("NodeTestFilter") )
            return false;
        throw new Error(
                        "Method isSupported("+feature
                        +","+version+") not known."
                        );
    }

    public void normalize() {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: normalize()");
    }
    public Node removeChild(Node parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: removeChild()");
    }
    public Node replaceChild(Node parm1, Node parm2)
        throws org.w3c.dom.DOMException
    {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: replaceChild()");
    }
    public void setNodeValue(String data) throws org.w3c.dom.DOMException {
        getSpartanText().setData(data);
    }
    public void setPrefix(String parm1) throws org.w3c.dom.DOMException {
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: setPrefix()");
    }

    ////////////////////////////////////////////////////
    // BEGIN DOM 3

    public boolean getIsWhitespaceInElementContent(){
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: setPrefix()");
    }

    public String getWholeText(){
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: setPrefix()");
    }

    public Text replaceWholeText(String content)
        throws org.w3c.dom.DOMException{
        /**@todo: Implement this org.w3c.dom.Node method*/
        throw new Error("not implemented: setPrefix()");
    }

    // END DOM 3
    ////////////////////////////////////////////////////

    com.rimfaxe.xml.xmlreader.Text getSpartanText(){
        return (com.rimfaxe.xml.xmlreader.Text)getSpartan();
    }

    TextImpl(
             DocumentImpl doc,
             com.rimfaxe.xml.xmlreader.Text spartan
             )
    {
        super(doc,spartan);
    }

}

// $Log: TextImpl.java,v $
// Revision 1.3  2002/11/06 02:59:55  eobrain
// Organize imputs to removed unused imports.  Remove some unused local variables.
//
// Revision 1.2  2002/08/21 20:19:10  eobrain
// Also implement CDATASection.
//
// Revision 1.1.1.1  2002/08/19 05:04:13  eobrain
// import from HP Labs internal CVS
//
// Revision 1.6  2002/08/18 05:46:24  eob
// Add copyright and other formatting and commenting in preparation for
// release to SourceForge.
//
// Revision 1.5  2002/06/21 00:34:49  eob
// Make work with old JDK 1.1.*
//
// Revision 1.4  2002/05/02 23:01:50  eob
// Handle test fot NodeTestFilter feature.
//
// Revision 1.3  2002/02/23 01:44:56  eob
// Implement some methods that had just been stubs.
//
// Revision 1.2  2002/02/08 20:34:04  eob
// Added extra DOM3 stuff.
//
// Revision 1.1  2002/01/05 07:40:08  eob
// initial
